//+------------------------------------------------------------------+
//|                                         Triangular Arbitrage.mq4 |
//|                                                   Amritendu Maji |
//|                                                             None |
//+------------------------------------------------------------------+
#property copyright "Amritendu Maji"
#property link      "None"

#property indicator_separate_window

#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_width1 2
#property indicator_color2 Magenta
#property indicator_width2 2
extern string S1 = "EURUSD";
extern string S2 = "USDJPY";
extern string S3 = "EURJPY";

extern double MinPips = 15;
extern double ProfitPips = 5;

int line_centre = 5;  //minimum bars

//---- buffers
double S1Buffer[];
double S2Buffer[];
double S3Buffer[];
double BuyBuffer[];
double ShortBuffer[];

int   cnt1, cnt2, temp0, temp1 = 0;
int   ia, ib, ic, id, ie = 0;
double v1, v2,v3, v4;
double S1_Spread, S2_Spread, S3_Spread;
double S1_bid, S1_ask, S2_bid, S2_ask, S3_bid, S3_ask;
double S1S2_bid, S1S2_ask;
int S3_digits;
double S3_point;
double MinValue;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,BuyBuffer);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ShortBuffer);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
/*
   ObjectDelete(S1_Obj);
   ObjectDelete(S2_Obj);
   ObjectDelete(S3_Obj);
*/   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   ArrayCopySeries(S1Buffer, MODE_CLOSE, S1, Period());
   ArrayCopySeries(S2Buffer, MODE_CLOSE, S2, Period());
   ArrayCopySeries(S3Buffer, MODE_CLOSE, S3, Period());

   temp0 = Bars - 1;
   if(ArraySize(S1Buffer) < temp0 + 1)  
     {
       temp0 = ArraySize(S1Buffer) - 1;
       Comment(S1 + " " + Period() + " " + ArraySize(S1Buffer));
     }
   if(ArraySize(S2Buffer) < temp0 + 1)  
     {
       temp0 = ArraySize(S2Buffer) - 1;
       Comment(S2 + " " + Period() + " " + ArraySize(S2Buffer));
     }
   if(ArraySize(S3Buffer) < temp0 + 1)  
     {
       temp0 = ArraySize(S3Buffer) - 1;
       Comment(S3 + " " + Period() + " " + ArraySize(S3Buffer));
     }
   if(line_centre >= temp0) 
     {
       Comment("Less that minimum bars.... ");
       return(0);
     }
     
   if(temp0 - line_centre < Bars - counted_bars)  
       temp1 = temp0 - line_centre;
   else  
       temp1 = Bars - counted_bars;
       
//   for(ia = temp1; ia >= 0; ia--) 
   for(ia = 0; ia <= temp1; ia++) 
     {
      S1_Spread = MarketInfo(S1, MODE_SPREAD)*MarketInfo(S1, MODE_POINT);
      S2_Spread = MarketInfo(S2, MODE_SPREAD)*MarketInfo(S2, MODE_POINT);
      S3_Spread = MarketInfo(S3, MODE_SPREAD)*MarketInfo(S3, MODE_POINT);
  
      S3_digits = MarketInfo(S3, MODE_DIGITS);
      S3_point = MarketInfo(S3, MODE_POINT);
      
      MinValue = MinPips;
      

      v1 = NormalizeDouble((S1Buffer[ia]+S1_Spread)*(S2Buffer[ia]+S2_Spread),S3_digits);
      v2 = NormalizeDouble(S3Buffer[ia]+S3_Spread,S3_digits); 
      v3 = NormalizeDouble(S1Buffer[ia]*S2Buffer[ia],S3_digits);
      v4 = NormalizeDouble(S3Buffer[ia],S3_digits); 
      
      Comment("v1=",v1," v2=",v2," v3=",v3," v4=",v4);

       if((v3 - v2) > MinValue*S3_point)
       {
        BuyBuffer[ia] = NormalizeDouble((v3 - v2)/S3_point,0);
        ShortBuffer[ia] = 0;
       }
       else if((v4 - v1) > MinValue*S3_point)
       {
        ShortBuffer[ia] = -NormalizeDouble((v4-v1)/S3_point,0);
        BuyBuffer[ia] = 0;
       }
       else
       {
        ShortBuffer[ia] = 0;
        BuyBuffer[ia] = 0;
       }

     }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+